# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/04_walk.ipynb.

# %% auto 0
__all__ = ['walktree']

# %% ../nbs/04_walk.ipynb 5
import os
from pathlib import Path
from typing import (Any, Generator, Optional)

# %% ../nbs/04_walk.ipynb 7
from atyp import (RichTree, PathFormatFunc)
from nchr import TreeChr
from pfmt import fmtpath
from chck.path import ishidden

# %% ../nbs/04_walk.ipynb 9
from .util import fullpath, pathsort

# %% ../nbs/04_walk.ipynb 11
def walktree(
    path: Path, tree: Optional[RichTree] = None,
    prefix: str = '', hidden: bool = False, fmtfunc: PathFormatFunc = fmtpath,
) -> Generator[str, Any, Any]:
    
    path = fullpath(path or os.getcwd())
    srtd = pathsort(path)
    strs = [TreeChr.TEE] * (len(srtd) - 1) + [TreeChr.END]
       
    for tstr, path in zip(strs, srtd):
        if ishidden(path) and not hidden: continue
        name = fmtfunc(path, prefix, tstr, suffix='')       
        brch = tree.add(name) if tree else None
        yield name
        
        if path.is_dir():
            newfix = TreeChr.join(prefix, tstr)
            yield from walktree(path, tree=brch, prefix=newfix, hidden=hidden, fmtfunc=fmtfunc)
